//
//  MyGround.m
//  TestApp3
//
//  Created by Yuji Nomura on 14/03/25.
//
//

#import "Ground.h"
#import <OpenGLES/ES1/gl.h>

@implementation Ground

GLfloat vertices[8*8/2 * 6*3];
GLfloat norms[8*8/2 * 6*3];

float ground_z = 0.0f;

GLuint err;

+ (void)initialize
{
    int num = 0;  //num of vertices
    err = glGetError();
    for(int x = -4; x < 4; x++){
        for(int z = -4; z < 4; z++){
            //if ((x+z) % 2 == 0) {
            if ((x ^ z) & 1) {
                int num_bak = num;
                vertices[num++] = x;	vertices[num++] = 0.0f;	vertices[num++] = z;
                vertices[num++] = x;	vertices[num++] = 0.0f;	vertices[num++] = z+1;
                vertices[num++] = x+1;	vertices[num++] = 0.0f;	vertices[num++] = z+1;
                vertices[num++] = x+1;	vertices[num++] = 0.0f;	vertices[num++] = z+1;
                vertices[num++] = x+1;	vertices[num++] = 0.0f;	vertices[num++] = z;
                vertices[num++] = x;	vertices[num++] = 0.0f;	vertices[num++] = z;
                
                num = num_bak;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
                norms[num++] = 0;	norms[num++] = 1;	norms[num++] = 0;
            }
        }
    }
    err = glGetError();
    err = glGetError();
}

float black[] = {0.3f, 0.3f, 0.3f, 1.0f};
float white[] = {0.7f, 0.7f, 0.7f, 1.0f};

+ (void)draw
{
    float ground_z_tmp = ground_z;
    Boolean swapWB = false;
    if (ground_z < 0) {
        ground_z_tmp += 1.0f;
        swapWB = true;
    }
    
    glPushMatrix();
    glTranslatef(0, -0.9f, ground_z_tmp);
        
    glVertexPointer(3, GL_FLOAT, 0, vertices);
    glNormalPointer(GL_FLOAT, 0, norms);
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);

    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, swapWB ? black : white);
    glDrawArrays(GL_TRIANGLES, 0, 8*8/2 * 6);
    
    glRotatef(90, 0, 1, 0);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, swapWB ? white : black);
    glDrawArrays(GL_TRIANGLES, 0, 8*8/2 * 6);
    
    glPopMatrix();

}

+(void)update
{
	ground_z -= 0.1;
	if (ground_z < -0.99) ground_z = 1.0;
}

+(void)setHue:(float)hue
{
    UIColor *color;
    color = [UIColor colorWithHue:hue saturation:0.2 brightness:0.3 alpha:1.00];
    [color getRed: &black[0] green:&black[1] blue:&black[2] alpha:&black[3]];
    color = [UIColor colorWithHue:hue saturation:0.2 brightness:0.7 alpha:1.00];
    [color getRed: &white[0] green:&white[1] blue:&white[2] alpha:&white[3]];
}

@end
