//
//  MyQuat.h
//  TestApp4
//
//  Created by Yuji Nomura on 14/04/13.
//
//

#ifndef MyQuat_h
#define MyQuat_h

typedef struct { float w, x, y, z; } Quat4f;  /* of (w + xi + yj + zk) */
#define UNIT_QUAT4F_CONSTANT {1, 0, 0, 0}
const Quat4f UNIT_QUAT4F;

extern void normalize_quat(Quat4f *q);
extern void get_conjugate_quat(const Quat4f *q, Quat4f *result);
extern void mul_quat(const Quat4f *p, const Quat4f *q, Quat4f *result);
extern void get_rot_quat(const float x, const float y, const float z, double angle, Quat4f *result);
extern void cross_product_quat(const Quat4f *p, const Quat4f *q, Quat4f *result);
extern void get_rot_quat_from_quats(const Quat4f *p, const Quat4f *q, double angle, Quat4f *result);
extern void scale_quat_angle(Quat4f *q, float scale);
extern void damp_quat_angle(Quat4f *q, float attenuation);
extern void quat_to_matrix(const Quat4f *q, float m[16]);
extern void slerp_quat(const Quat4f *p, const Quat4f *q, float t, Quat4f *result);

#endif
